include<tile.scad>;
include<LX15D.scad>;

screw_d = 3;
t = 3;
tube_d = 4;
local_tile_t = 5;
coxa_z_space = 40;

module body_collision_a(positions) {
    hull() for (pos = positions) {
        translate(pos)
            cube([ LX15D_dim[1], LX15D_dim[1], LX15D_horn_w ], center = true);
    }
}

module top_tiles() {
    translate([ 0, 0, (coxa_z_space + t) / 2 ]) {
        for (j = [-2:2])
            translate([ 0, j * tile_a, 0 ]) tile_base(local_tile_t, 0);
        for (i = [ -1, 0, 1 ])
            translate([ i * tile_a, 0, 0 ]) tile_base(local_tile_t, 0);
    }
}
module bot_tiles() {
    translate([ 0, 0, -(coxa_z_space + t) / 2 ]) {
        for (j = [-2:2])
            translate([ 0, j * tile_a, 0 ]) tile_base(local_tile_t, 0);
        for (i = [ -1, 0, 1 ])
            translate([ i * tile_a, 0, 0 ]) tile_base(local_tile_t, 0);
    }
}

module body(positions) {
    $fn = 32;

    for (pos = positions) translate(pos) {
            if (pos[1] > 0) {
                rotate([ 0, 0, -90 ]) LX15D();
            } else {
                rotate([ 0, 0, 90 ]) LX15D();
            }
        }

    top_tiles();
    bot_tiles();
}
