include<LX15D.scad>;
include<tile.scad>;

t = 3;
screw_d = 3;
hole_d = 10;

module collision_cube() {
    translate([ 0, LX15D_horn_w / 2 + t / 2, 0 ])
        cube([ LX15D_dim[1], t, LX15D_dim[1] ], center = true);
}

module femur_collision_a(tibiaOffset) {
    hull() {
        collision_cube();
        middle_pos(tibiaOffset) collision_cube();
    }
    hull() {
        middle_pos(tibiaOffset) collision_cube();
        translate(tibiaOffset) collision_cube();
    }
}
module femur_collision_b(tibiaOffset) {
    mirror([ 0, 1, 0 ]) femur_collision_a(tibiaOffset);
}

module screw_pos(tibiaOffset) translate([ 0, LX15D_horn_w / 2, 0 ]) {
    rotate([ -90, 0, 0 ]) LX15D_horn_screw_pos() children();
    translate(tibiaOffset) rotate([ -90, 45, 0 ]) LX15D_horn_screw_pos()
        children();
}

module screw_center(tibiaOffset) translate([ 0, LX15D_horn_w / 2, 0 ]) {
    rotate([ -90, 0, 0 ]) children();
    translate(tibiaOffset) rotate([ -90, 0, 0 ]) children();
}

function middle_pos_f(tibiaOffset) = [ tibiaOffset[2], 0, tibiaOffset[2] ];

module middle_pos(tibiaOffset) {
    translate(middle_pos_f(tibiaOffset)) children();
}

module screw() { cylinder(d = screw_d + t * 2, h = t); }


module femur_plate(tibiaOffset) {
    translate([ 0, LX15D_horn_w / 2 + 5 / 2, 0 ]) {
        rotate([ 90, 45, 0 ]) scale([ 0.5, 0.5, 1 ]) for (i = [1:3])
            translate([ 0, i * tile_a, 0 ]) tile_base(5);
        translate(tibiaOffset) scale([ 0.5, 1, 0.5 ])
            rotate([ 90, 0, 0 ]) for (i = [-1:-3])
                translate([ i * tile_a, 0, 0 ]) tile_base(5);
    }
    difference() {
        translate([ 0, LX15D_horn_w / 2, 0 ]) union() {
            hull() { rotate([ -90, 0, 0 ]) LX15D_horn_screw_pos() screw(); }
            hull() translate(tibiaOffset) rotate([ -90, 45, 0 ])
                LX15D_horn_screw_pos() screw();
        }
        screw_pos(tibiaOffset) cylinder(d = screw_d, h = 100, center = true);
        screw_center(tibiaOffset)
            cylinder(d = LX15D_horn_clearance_d, h = 100, center = true);
    }
}

$fa = 1.5;
$fs = 1.5;

module femur(tibiaOffset) {
    color("purple") {
        for (m = [ 0, 1 ]) mirror([ 0, m, 0 ]) femur_plate(tibiaOffset);
    }
}

femur([ 100, 0, 45 ]);
